#ifndef SOPTWORK_H
#define SOPTWORK_H

#include "sopttraderapi.h"
#include "sopttraderspi.h"
#include "define.h"
#include "getconfig.h"
#include "DataCollect.h"
#include <iostream>

#ifdef __WIN_SYS
#include <Windows.h>
#elif defined(__UNIX_SYS)
#include <semaphore.h>
#endif 


class CUser : public CTraderSpi
{
public:
	CUser();
	~CUser();

public:
	CTraderApi *m_pTrader;
	int RequestID;
	TThostFtdcBrokerIDType	m_BrokerID;
	TThostFtdcUserIDType	m_UserID;
	TThostFtdcAuthCodeType	m_AuthCode;
	TThostFtdcAppIDType	m_AppID;
	TThostFtdcPasswordType	m_Password;
	TThostFtdcInvestorIDType	m_InvestorID;
	TThostFtdcInstrumentIDType	m_InstrumentID;
	TThostFtdcExchangeIDType	m_ExchangeID;
	string m_FrontAddr;
	bool m_loginflag;

public:
	void Release();
	void Init();
	void Join();

	//req
	void ReqAuthenticate();
	void RegisterUserSystemInfo();
	void SubmitUserSystemInfo();
	void ReqUserLogin();
	void ReqUserLogout();
	void ReqUserPasswordUpdate();
	void ReqTradingAccountPasswordUpdate();
	void ReqOrderInsert();
	void ReqParkedOrderInsert();
	void ReqParkedOrderAction();
	void ReqOrderAction();
	void ReqQueryMaxOrderVolume();
	void ReqSettlementInfoConfirm();
	void ReqRemoveParkedOrder();
	void ReqRemoveParkedOrderAction();
	void ReqExecOrderInsert();
	void ReqExecOrderAction();
	void ReqForQuoteInsert();
	void ReqQuoteInsert();
	void ReqQuoteAction();
	void ReqLockInsert();
	void ReqBatchOrderAction();
	void ReqCombActionInsert();
	void ReqQryOrder();
	void ReqQryTrade();
	void ReqQryInvestorPosition();
	void ReqQryTradingAccount();
	void ReqQryInvestor();
	void ReqQryTradingCode();
	void ReqQryInstrumentMarginRate();
	void ReqQryInstrumentCommissionRate();
	void ReqQryExchange();
	void ReqQryProduct();
	void ReqQryInstrument();
	void ReqQryDepthMarketData();
	void ReqQrySettlementInfo();
	void ReqQryTransferBank();
	void ReqQryInvestorPositionDetail();
	void ReqQryNotice();
	void ReqQrySettlementInfoConfirm();
	void ReqQryInvestorPositionCombineDetail();
	void ReqQryCFMMCTradingAccountKey();
	void ReqQryEWarrantOffset();
	void ReqQryInvestorProductGroupMargin();
	void ReqQryExchangeMarginRate();
	void ReqQryExchangeMarginRateAdjust();
	void ReqQryExchangeRate();
	void ReqQrySecAgentACIDMap();
	void ReqQryProductExchRate();
	void ReqQryProductGroup();
	void ReqQryMMInstrumentCommissionRate();
	void ReqQryMMOptionInstrCommRate();
	void ReqQryInstrumentOrderCommRate();
	void ReqQryOptionInstrTradeCost();
	void ReqQryOptionInstrCommRate();
	void ReqQryExecOrder();
	void ReqQryForQuote();
	void ReqQryQuote();
	void ReqQryLock();
	void ReqQryLockPosition();
	void ReqQryETFOptionInstrCommRate();
	void ReqQryInvestorLevel();
	void ReqQryExecFreeze();
	void ReqQryCombInstrumentGuard();
	void ReqQryCombAction();
	void ReqQryTransferSerial();
	void ReqQryAccountregister();
	void ReqQryContractBank();
	void ReqQryParkedOrder();
	void ReqQryParkedOrderAction();
	void ReqQryTradingNotice();
	void ReqQryBrokerTradingParams();
	void ReqQryBrokerTradingAlgos();
	void ReqQueryCFMMCTradingAccountToken();
	void ReqFromBankToFutureByFuture();
	void ReqFromFutureToBankByFuture();
	void ReqQueryBankAccountMoneyByFuture();
	void ReqReserveOpenAccountTpdByFuture();
	void ReqSecuritiesDepositInterestByFuture();
	void ReqDayEndFileReadyByFuture();
	void ReqExecCombineOrderInsert();
	void ReqExecCombineOrderAction();
	void ReqQryExecCombineOrder();

	////360汾
	void ReqInternalTransfer();
	void ReqQryLimitAmount();
	void ReqQryLimitPosi();

	//rsp
	void OnFrontConnected();
	void OnFrontDisconnected(int nReason);
	void OnHeartBeatWarning(int nTimeLapse);
	void OnRspAuthenticate(CThostFtdcRspAuthenticateField *pRspAuthenticateField, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspUserLogin(CThostFtdcRspUserLoginField *pRspUserLogin, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspUserLogout(CThostFtdcUserLogoutField *pUserLogout, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspUserPasswordUpdate(CThostFtdcUserPasswordUpdateField *pUserPasswordUpdate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspTradingAccountPasswordUpdate(CThostFtdcTradingAccountPasswordUpdateField *pTradingAccountPasswordUpdate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspOrderInsert(CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspParkedOrderInsert(CThostFtdcParkedOrderField *pParkedOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspParkedOrderAction(CThostFtdcParkedOrderActionField *pParkedOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspOrderAction(CThostFtdcInputOrderActionField *pInputOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQueryMaxOrderVolume(CThostFtdcQueryMaxOrderVolumeField *pQueryMaxOrderVolume, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspSettlementInfoConfirm(CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspRemoveParkedOrder(CThostFtdcRemoveParkedOrderField *pRemoveParkedOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspRemoveParkedOrderAction(CThostFtdcRemoveParkedOrderActionField *pRemoveParkedOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspExecOrderInsert(CThostFtdcInputExecOrderField *pInputExecOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspExecOrderAction(CThostFtdcInputExecOrderActionField *pInputExecOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspForQuoteInsert(CThostFtdcInputForQuoteField *pInputForQuote, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQuoteInsert(CThostFtdcInputQuoteField *pInputQuote, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQuoteAction(CThostFtdcInputQuoteActionField *pInputQuoteAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspLockInsert(CThostFtdcInputLockField *pInputLock, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspBatchOrderAction(CThostFtdcInputBatchOrderActionField *pInputBatchOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspCombActionInsert(CThostFtdcInputCombActionField *pInputCombAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryOrder(CThostFtdcOrderField *pOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryTrade(CThostFtdcTradeField *pTrade, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInvestorPosition(CThostFtdcInvestorPositionField *pInvestorPosition, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryTradingAccount(CThostFtdcTradingAccountField *pTradingAccount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInvestor(CThostFtdcInvestorField *pInvestor, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryTradingCode(CThostFtdcTradingCodeField *pTradingCode, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInstrumentMarginRate(CThostFtdcInstrumentMarginRateField *pInstrumentMarginRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInstrumentCommissionRate(CThostFtdcInstrumentCommissionRateField *pInstrumentCommissionRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryExchange(CThostFtdcExchangeField *pExchange, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryProduct(CThostFtdcProductField *pProduct, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInstrument(CThostFtdcInstrumentField *pInstrument, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryDepthMarketData(CThostFtdcDepthMarketDataField *pDepthMarketData, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQrySettlementInfo(CThostFtdcSettlementInfoField *pSettlementInfo, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryTransferBank(CThostFtdcTransferBankField *pTransferBank, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInvestorPositionDetail(CThostFtdcInvestorPositionDetailField *pInvestorPositionDetail, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryNotice(CThostFtdcNoticeField *pNotice, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQrySettlementInfoConfirm(CThostFtdcSettlementInfoConfirmField *pSettlementInfoConfirm, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInvestorPositionCombineDetail(CThostFtdcInvestorPositionCombineDetailField *pInvestorPositionCombineDetail, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryCFMMCTradingAccountKey(CThostFtdcCFMMCTradingAccountKeyField *pCFMMCTradingAccountKey, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryEWarrantOffset(CThostFtdcEWarrantOffsetField *pEWarrantOffset, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInvestorProductGroupMargin(CThostFtdcInvestorProductGroupMarginField *pInvestorProductGroupMargin, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryExchangeMarginRate(CThostFtdcExchangeMarginRateField *pExchangeMarginRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryExchangeMarginRateAdjust(CThostFtdcExchangeMarginRateAdjustField *pExchangeMarginRateAdjust, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryExchangeRate(CThostFtdcExchangeRateField *pExchangeRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQrySecAgentACIDMap(CThostFtdcSecAgentACIDMapField *pSecAgentACIDMap, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryProductExchRate(CThostFtdcProductExchRateField *pProductExchRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryProductGroup(CThostFtdcProductGroupField *pProductGroup, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryMMInstrumentCommissionRate(CThostFtdcMMInstrumentCommissionRateField *pMMInstrumentCommissionRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryMMOptionInstrCommRate(CThostFtdcMMOptionInstrCommRateField *pMMOptionInstrCommRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInstrumentOrderCommRate(CThostFtdcInstrumentOrderCommRateField *pInstrumentOrderCommRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryOptionInstrTradeCost(CThostFtdcOptionInstrTradeCostField *pOptionInstrTradeCost, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryOptionInstrCommRate(CThostFtdcOptionInstrCommRateField *pOptionInstrCommRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryExecOrder(CThostFtdcExecOrderField *pExecOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryForQuote(CThostFtdcForQuoteField *pForQuote, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryQuote(CThostFtdcQuoteField *pQuote, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryLock(CThostFtdcLockField *pLock, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryLockPosition(CThostFtdcLockPositionField *pLockPosition, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryETFOptionInstrCommRate(CThostFtdcETFOptionInstrCommRateField *pETFOptionInstrCommRate, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryInvestorLevel(CThostFtdcInvestorLevelField *pInvestorLevel, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryExecFreeze(CThostFtdcExecFreezeField *pExecFreeze, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryCombInstrumentGuard(CThostFtdcCombInstrumentGuardField *pCombInstrumentGuard, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryCombAction(CThostFtdcCombActionField *pCombAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryTransferSerial(CThostFtdcTransferSerialField *pTransferSerial, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryAccountregister(CThostFtdcAccountregisterField *pAccountregister, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspError(CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRtnOrder(CThostFtdcOrderField *pOrder);
	void OnRtnTrade(CThostFtdcTradeField *pTrade);
	void OnErrRtnOrderInsert(CThostFtdcInputOrderField *pInputOrder, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnOrderAction(CThostFtdcOrderActionField *pOrderAction, CThostFtdcRspInfoField *pRspInfo);
	void OnRtnInstrumentStatus(CThostFtdcInstrumentStatusField *pInstrumentStatus);
	void OnRtnBulletin(CThostFtdcBulletinField *pBulletin);
	void OnRtnTradingNotice(CThostFtdcTradingNoticeInfoField *pTradingNoticeInfo);
	void OnRtnErrorConditionalOrder(CThostFtdcErrorConditionalOrderField *pErrorConditionalOrder);
	void OnRtnExecOrder(CThostFtdcExecOrderField *pExecOrder);
	void OnErrRtnExecOrderInsert(CThostFtdcInputExecOrderField *pInputExecOrder, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnExecOrderAction(CThostFtdcExecOrderActionField *pExecOrderAction, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnForQuoteInsert(CThostFtdcInputForQuoteField *pInputForQuote, CThostFtdcRspInfoField *pRspInfo);
	void OnRtnQuote(CThostFtdcQuoteField *pQuote);
	void OnErrRtnQuoteInsert(CThostFtdcInputQuoteField *pInputQuote, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnQuoteAction(CThostFtdcQuoteActionField *pQuoteAction, CThostFtdcRspInfoField *pRspInfo);
	void OnRtnForQuoteRsp(CThostFtdcForQuoteRspField *pForQuoteRsp);
	void OnRtnCFMMCTradingAccountToken(CThostFtdcCFMMCTradingAccountTokenField *pCFMMCTradingAccountToken);
	void OnRtnLock(CThostFtdcLockField *pLock);
	void OnErrRtnLockInsert(CThostFtdcInputLockField *pInputLock, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnBatchOrderAction(CThostFtdcBatchOrderActionField *pBatchOrderAction, CThostFtdcRspInfoField *pRspInfo);
	void OnRtnCombAction(CThostFtdcCombActionField *pCombAction);
	void OnErrRtnCombActionInsert(CThostFtdcInputCombActionField *pInputCombAction, CThostFtdcRspInfoField *pRspInfo);
	void OnRspQryContractBank(CThostFtdcContractBankField *pContractBank, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryParkedOrder(CThostFtdcParkedOrderField *pParkedOrder, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryParkedOrderAction(CThostFtdcParkedOrderActionField *pParkedOrderAction, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryTradingNotice(CThostFtdcTradingNoticeField *pTradingNotice, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryBrokerTradingParams(CThostFtdcBrokerTradingParamsField *pBrokerTradingParams, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryBrokerTradingAlgos(CThostFtdcBrokerTradingAlgosField *pBrokerTradingAlgos, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQueryCFMMCTradingAccountToken(CThostFtdcQueryCFMMCTradingAccountTokenField *pQueryCFMMCTradingAccountToken, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRtnFromBankToFutureByBank(CThostFtdcRspTransferField *pRspTransfer);
	void OnRtnFromFutureToBankByBank(CThostFtdcRspTransferField *pRspTransfer);
	void OnRtnRepealFromBankToFutureByBank(CThostFtdcRspRepealField *pRspRepeal);
	void OnRtnRepealFromFutureToBankByBank(CThostFtdcRspRepealField *pRspRepeal);
	void OnRtnFromBankToFutureByFuture(CThostFtdcRspTransferField *pRspTransfer);
	void OnRtnFromFutureToBankByFuture(CThostFtdcRspTransferField *pRspTransfer);
	void OnRtnRepealFromBankToFutureByFutureManual(CThostFtdcRspRepealField *pRspRepeal);
	void OnRtnRepealFromFutureToBankByFutureManual(CThostFtdcRspRepealField *pRspRepeal);
	void OnRtnQueryBankBalanceByFuture(CThostFtdcNotifyQueryAccountField *pNotifyQueryAccount);
	void OnErrRtnBankToFutureByFuture(CThostFtdcReqTransferField *pReqTransfer, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnFutureToBankByFuture(CThostFtdcReqTransferField *pReqTransfer, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnRepealBankToFutureByFutureManual(CThostFtdcReqRepealField *pReqRepeal, CThostFtdcRspInfoField *pRspInfo);
	void OnErrRtnRepealFutureToBankByFutureManual(CThostFtdcReqRepealField *pReqRepeal, CThostFtdcRspInfoField *pRspInfo);

	////360汾
	void OnRspQryLimitPosi(CThostFtdcLimitPosiField *pLimitPosi, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspQryLimitAmount(CThostFtdcLimitAmountField *pLimitAmount, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRspInternalTransfer(CThostFtdcInputInternalTransferField *pInputInternalTransfer, CThostFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast);
	void OnRtnInternalTransfer(CThostFtdcRtnInternalTransferField *pRtnInternalTransfer);

private:
#ifdef __WIN_SYS
	HANDLE m_Release_signal;
	HANDLE m_Init_signal;
	HANDLE m_Join_signal;
	HANDLE m_ReqAuthenticate_signal;
	HANDLE m_RegisterUserSystemInfo_signal;
	HANDLE m_SubmitUserSystemInfo_signal;
	HANDLE m_ReqUserLogin_signal;
	HANDLE m_ReqUserLogout_signal;
	HANDLE m_ReqUserPasswordUpdate_signal;
	HANDLE m_ReqTradingAccountPasswordUpdate_signal;
	HANDLE m_ReqOrderInsert_signal;
	HANDLE m_ReqParkedOrderInsert_signal;
	HANDLE m_ReqParkedOrderAction_signal;
	HANDLE m_ReqOrderAction_signal;
	HANDLE m_ReqQueryMaxOrderVolume_signal;
	HANDLE m_ReqSettlementInfoConfirm_signal;
	HANDLE m_ReqRemoveParkedOrder_signal;
	HANDLE m_ReqRemoveParkedOrderAction_signal;
	HANDLE m_ReqExecOrderInsert_signal;
	HANDLE m_ReqExecOrderAction_signal;
	HANDLE m_ReqForQuoteInsert_signal;
	HANDLE m_ReqQuoteInsert_signal;
	HANDLE m_ReqQuoteAction_signal;
	HANDLE m_ReqLockInsert_signal;
	HANDLE m_ReqBatchOrderAction_signal;
	HANDLE m_ReqCombActionInsert_signal;
	HANDLE m_ReqQryOrder_signal;
	HANDLE m_ReqQryTrade_signal;
	HANDLE m_ReqQryInvestorPosition_signal;
	HANDLE m_ReqQryTradingAccount_signal;
	HANDLE m_ReqQryInvestor_signal;
	HANDLE m_ReqQryTradingCode_signal;
	HANDLE m_ReqQryInstrumentMarginRate_signal;
	HANDLE m_ReqQryInstrumentCommissionRate_signal;
	HANDLE m_ReqQryExchange_signal;
	HANDLE m_ReqQryProduct_signal;
	HANDLE m_ReqQryInstrument_signal;
	HANDLE m_ReqQryDepthMarketData_signal;
	HANDLE m_ReqQrySettlementInfo_signal;
	HANDLE m_ReqQryTransferBank_signal;
	HANDLE m_ReqQryInvestorPositionDetail_signal;
	HANDLE m_ReqQryNotice_signal;
	HANDLE m_ReqQrySettlementInfoConfirm_signal;
	HANDLE m_ReqQryInvestorPositionCombineDetail_signal;
	HANDLE m_ReqQryCFMMCTradingAccountKey_signal;
	HANDLE m_ReqQryEWarrantOffset_signal;
	HANDLE m_ReqQryInvestorProductGroupMargin_signal;
	HANDLE m_ReqQryExchangeMarginRate_signal;
	HANDLE m_ReqQryExchangeMarginRateAdjust_signal;
	HANDLE m_ReqQryExchangeRate_signal;
	HANDLE m_ReqQrySecAgentACIDMap_signal;
	HANDLE m_ReqQryProductExchRate_signal;
	HANDLE m_ReqQryProductGroup_signal;
	HANDLE m_ReqQryMMInstrumentCommissionRate_signal;
	HANDLE m_ReqQryMMOptionInstrCommRate_signal;
	HANDLE m_ReqQryInstrumentOrderCommRate_signal;
	HANDLE m_ReqQryOptionInstrTradeCost_signal;
	HANDLE m_ReqQryOptionInstrCommRate_signal;
	HANDLE m_ReqQryExecOrder_signal;
	HANDLE m_ReqQryForQuote_signal;
	HANDLE m_ReqQryQuote_signal;
	HANDLE m_ReqQryLock_signal;
	HANDLE m_ReqQryLockPosition_signal;
	HANDLE m_ReqQryETFOptionInstrCommRate_signal;
	HANDLE m_ReqQryInvestorLevel_signal;
	HANDLE m_ReqQryExecFreeze_signal;
	HANDLE m_ReqQryCombInstrumentGuard_signal;
	HANDLE m_ReqQryCombAction_signal;
	HANDLE m_ReqQryTransferSerial_signal;
	HANDLE m_ReqQryAccountregister_signal;
	HANDLE m_ReqQryContractBank_signal;
	HANDLE m_ReqQryParkedOrder_signal;
	HANDLE m_ReqQryParkedOrderAction_signal;
	HANDLE m_ReqQryTradingNotice_signal;
	HANDLE m_ReqQryBrokerTradingParams_signal;
	HANDLE m_ReqQryBrokerTradingAlgos_signal;
	HANDLE m_ReqQueryCFMMCTradingAccountToken_signal;
	HANDLE m_ReqFromBankToFutureByFuture_signal;
	HANDLE m_ReqFromFutureToBankByFuture_signal;
	HANDLE m_ReqQueryBankAccountMoneyByFuture_signal;
	HANDLE m_ReqReserveOpenAccountTpdByFuture_signal;
	HANDLE m_ReqSecuritiesDepositInterestByFuture_signal;
	HANDLE m_ReqDayEndFileReadyByFuture_signal;
	HANDLE m_ReqExecCombineOrderInsert_signal;
	HANDLE m_ReqExecCombineOrderAction_signal;
	HANDLE m_ReqQryExecCombineOrder_signal;
#elif defined(__UNIX_SYS)
	sem_t m_Release_signal;
	sem_t m_Init_signal;
	sem_t m_Join_signal;
	sem_t m_ReqAuthenticate_signal;
	sem_t m_RegisterUserSystemInfo_signal;
	sem_t m_SubmitUserSystemInfo_signal;
	sem_t m_ReqUserLogin_signal;
	sem_t m_ReqUserLogout_signal;
	sem_t m_ReqUserPasswordUpdate_signal;
	sem_t m_ReqTradingAccountPasswordUpdate_signal;
	sem_t m_ReqOrderInsert_signal;
	sem_t m_ReqParkedOrderInsert_signal;
	sem_t m_ReqParkedOrderAction_signal;
	sem_t m_ReqOrderAction_signal;
	sem_t m_ReqQueryMaxOrderVolume_signal;
	sem_t m_ReqSettlementInfoConfirsem_t m_signal;
	sem_t m_ReqRemoveParkedOrder_signal;
	sem_t m_ReqRemoveParkedOrderAction_signal;
	sem_t m_ReqExecOrderInsert_signal;
	sem_t m_ReqExecOrderAction_signal;
	sem_t m_ReqForQuoteInsert_signal;
	sem_t m_ReqQuoteInsert_signal;
	sem_t m_ReqQuoteAction_signal;
	sem_t m_ReqLockInsert_signal;
	sem_t m_ReqBatchOrderAction_signal;
	sem_t m_ReqCombActionInsert_signal;
	sem_t m_ReqQryOrder_signal;
	sem_t m_ReqQryTrade_signal;
	sem_t m_ReqQryInvestorPosition_signal;
	sem_t m_ReqQryTradingAccount_signal;
	sem_t m_ReqQryInvestor_signal;
	sem_t m_ReqQryTradingCode_signal;
	sem_t m_ReqQryInstrumentMarginRate_signal;
	sem_t m_ReqQryInstrumentCommissionRate_signal;
	sem_t m_ReqQryExchange_signal;
	sem_t m_ReqQryProduct_signal;
	sem_t m_ReqQryInstrument_signal;
	sem_t m_ReqQryDepthMarketData_signal;
	sem_t m_ReqQrySettlementInfo_signal;
	sem_t m_ReqQryTransferBank_signal;
	sem_t m_ReqQryInvestorPositionDetail_signal;
	sem_t m_ReqQryNotice_signal;
	sem_t m_ReqQrySettlementInfoConfirsem_t m_signal;
	sem_t m_ReqQryInvestorPositionCombineDetail_signal;
	sem_t m_ReqQryCFMMCTradingAccountKey_signal;
	sem_t m_ReqQryEWarrantOffset_signal;
	sem_t m_ReqQryInvestorProductGroupMargin_signal;
	sem_t m_ReqQryExchangeMarginRate_signal;
	sem_t m_ReqQryExchangeMarginRateAdjust_signal;
	sem_t m_ReqQryExchangeRate_signal;
	sem_t m_ReqQrySecAgentACIDMap_signal;
	sem_t m_ReqQryProductExchRate_signal;
	sem_t m_ReqQryProductGroup_signal;
	sem_t m_ReqQryMMInstrumentCommissionRate_signal;
	sem_t m_ReqQryMMOptionInstrCommRate_signal;
	sem_t m_ReqQryInstrumentOrderCommRate_signal;
	sem_t m_ReqQryOptionInstrTradeCost_signal;
	sem_t m_ReqQryOptionInstrCommRate_signal;
	sem_t m_ReqQryExecOrder_signal;
	sem_t m_ReqQryForQuote_signal;
	sem_t m_ReqQryQuote_signal;
	sem_t m_ReqQryLock_signal;
	sem_t m_ReqQryLockPosition_signal;
	sem_t m_ReqQryETFOptionInstrCommRate_signal;
	sem_t m_ReqQryInvestorLevel_signal;
	sem_t m_ReqQryExecFreeze_signal;
	sem_t m_ReqQryCombInstrumentGuard_signal;
	sem_t m_ReqQryCombAction_signal;
	sem_t m_ReqQryTransferSerial_signal;
	sem_t m_ReqQryAccountregister_signal;
	sem_t m_ReqQryContractBank_signal;
	sem_t m_ReqQryParkedOrder_signal;
	sem_t m_ReqQryParkedOrderAction_signal;
	sem_t m_ReqQryTradingNotice_signal;
	sem_t m_ReqQryBrokerTradingParams_signal;
	sem_t m_ReqQryBrokerTradingAlgos_signal;
	sem_t m_ReqQueryCFMMCTradingAccountToken_signal;
	sem_t m_ReqFromBankToFutureByFuture_signal;
	sem_t m_ReqFromFutureToBankByFuture_signal;
	sem_t m_ReqQueryBankAccountMoneyByFuture_signal;
	sem_t m_ReqReserveOpenAccountTpdByFuture_signal;
	sem_t m_ReqSecuritiesDepositInterestByFuture_signal;
	sem_t m_ReqDayEndFileReadyByFuture_signal;
	sem_t m_ReqExecCombineOrderInsert_signal;
	sem_t m_ReqExecCombineOrderAction_signal;
	sem_t m_ReqQryExecCombineOrder_signal;
#endif // __WIN_SYS

};

#endif // SOPTWORK_H

